class TopController < ApplicationController
  layout 'test' if MagicNumber['test_layout']
  if MagicNumber['run_mode'] == 0
    before_filter :authenticate_user, :only => []
    before_filter :authenticate_author, :only => []
  else
    before_filter :authenticate_reader, :only => [:index, :metro]
    before_filter :authenticate_user, :only => []
    before_filter :authenticate_author, :only => []
  end
  
  def index
    respond_to do |format|
      format.html 
    end
  end
  
  def metro
    respond_to do |format|
      format.html 
      #format.html { render layout: 'metro' }
    end
  end
  
end
